image: docker:19.03

stages:
    - build 
    - deploy

variables: 
    VERSION: 1

build_app:
    stage: build

    tags:
    - mlops_project

    before_script:
        - 'which ssh-agent || ( apt-get install -y -qq openssh-client )'
        - eval $(ssh-agent -s)
        - mkdir -p ~/.ssh
        - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
        - echo "$SSH_PRIV_KEY" | ssh-add -

    script: 
        - ssh  $HOST_1 "mkdir -p /projects/data"
        - ssh  $HOST_1 "mkdir -p /projects/app"

        - scp -r $CI_PROJECT_DIR/data/* root@$HOST_1:/projects/data/

        - scp -r $CI_PROJECT_DIR/app.py root@$HOST_1:/projects/app/
        - scp -r $CI_PROJECT_DIR/Dockerfile root@$HOST_1:/projects/app/
        - scp -r $CI_PROJECT_DIR/requirements.txt root@$HOST_1:/projects/app/

        - ssh $HOST_1 "echo '$VERSION' > /projects/app/env"

        - ssh  $HOST_1 "docker build -t 'project_app' /projects/app"

deploy_app:
    stage: deploy

    tags:
    - mlops_project

    before_script:
        - 'which ssh-agent || ( apt-get install -y -qq openssh-client )'
        - eval $(ssh-agent -s)
        - mkdir -p ~/.ssh
        - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
        - echo "$SSH_PRIV_KEY" | ssh-add -

    script: 
        - ssh  $HOST_1 "docker service create --replicas 2 --name my_project_app --publish published=4000,target=4200 --mount type=bind,source=/projects/data,destination=/projects/data --constraint node.labels.host==$VERSION --update-delay 45s project_app"
